#ifndef ACD_H
#define ACD_H
#include "CallManager.h"
#include "CallObserver.h"
#include <list>
#include <map>
#include "Agent.h"
#include "Queue.h"
#include "AgentManager.h"
#include "StaticConfiguration.h"
#include "JSON.h"

typedef std::map<std::string,Queue*> QueueList;

class Acd: public CallObserver, public RTPObserver{
private:
    AgentManager *mAgentManager;
    StaticConfiguration *mConfig;
public:
	Acd(CallManager *callManager,AgentManager *am, StaticConfiguration *config);
	~Acd();

    void work();



    void onRTPSessionSoundQueueEmpty(Call *call);
    void onCallTerminated(Call *call);
    void onCallAnswered(Call *call);
    void onCallFailed(Call *call);
    void onRONA(Call *call);
    void onIncommingCallAnswered(Call *call);
    void onIncommingCall(Call *call);
    void onDTMF(Call *call,std::string digit);

    Queue* createQueue(std::string name);
    Queue* getQueue(std::string name);

    void getQueuesStats(Dumais::JSON::JSON& json);
    void getAgentsStats(Dumais::JSON::JSON& json);

private:
    bool test;
    CallManager *mCallManager;

    std::string mLoginExtension;
    std::string mLogoutExtension;
    QueueList mQueueList;

};

#endif

