#ifndef AGENTMANAGER_H
#define AGENTMANAGER_H
#include "UserAgent.h"
#include <resip/dum/SubscriptionHandler.hxx>
#include "Agent.h"
#include "JSON.h"

typedef std::map<std::string,Agent*> AgentList;

class Queue;

class AgentManager: public resip::ClientSubscriptionHandler{
private:
    UserAgent* mUserAgent;
    bool subscribeAgent(Agent *agent);

    AgentList mAgentList;
    int mSubscribeExpire;

public:
	AgentManager(UserAgent *userAgent, int expire);
	~AgentManager();

    void work();

    virtual void onUpdatePending (resip::ClientSubscriptionHandle, const resip::SipMessage &notify, bool outOfOrder);
    virtual void onUpdateActive (resip::ClientSubscriptionHandle, const resip::SipMessage &notify, bool outOfOrder);
    virtual void onUpdateExtension (resip::ClientSubscriptionHandle, const resip::SipMessage &notify, bool outOfOrder);
    virtual int onRequestRetry (resip::ClientSubscriptionHandle, int retrySeconds, const resip::SipMessage &notify);
    virtual void onTerminated (resip::ClientSubscriptionHandle, const resip::SipMessage *msg);
    virtual void onNewSubscription (resip::ClientSubscriptionHandle, const resip::SipMessage &notify);
    virtual void onReadyToSend (resip::ClientSubscriptionHandle, resip::SipMessage &msg);
    virtual void onNotifyNotReceived (resip::ClientSubscriptionHandle);
    virtual void onFlowTerminated (resip::ClientSubscriptionHandle);

    void addAgent(Agent* agent);
    Agent* getAgent(std::string agent);
    Agent* getMostIdleAgentForQueue(Queue *q);
    Agent* getAgentWithDevice(resip::NameAddr);

    void toJSON(Dumais::JSON::JSON& json);
};



#endif

