#include "AppDialogSetPeriodicAnnouncementCommand.h"
#include "Call.h"
#include "Logging.h"
#include <resip/dum/DialogUsageManager.hxx>

using namespace resip;
AppDialogSetPeriodicAnnouncementCommand::AppDialogSetPeriodicAnnouncementCommand(std::string file, int delay,resip::AppDialogSetHandle h): mHandle(h){
    this->mFile = file;
    this->mDelay = delay;
}

AppDialogSetPeriodicAnnouncementCommand::~AppDialogSetPeriodicAnnouncementCommand(){
}

void AppDialogSetPeriodicAnnouncementCommand::executeCommand()
{
    Logging::log("AppDialogSetPeriodicAnnouncementCommand::executeCommand\r\n");
    if(mHandle.isValid())
    {
        Call *call = dynamic_cast<Call*>(mHandle.get());
        if (call)
        {
            call->getRTPSession()->play(this->mFile.c_str());

            //post another announcement
            AppDialogSetPeriodicAnnouncementCommand cmd(mFile,mDelay,mHandle);
            call->getDUM().getSipStack().post(cmd,this->mDelay,&call->getDUM());
        }
    }
}

Message* AppDialogSetPeriodicAnnouncementCommand::clone() const
{
    AppDialogSetPeriodicAnnouncementCommand *cmd = new AppDialogSetPeriodicAnnouncementCommand(mFile,mDelay,mHandle);

    return cmd;
}
std::ostream& AppDialogSetPeriodicAnnouncementCommand::encode(std::ostream& strm) const
{
    return strm;
}
std::ostream& AppDialogSetPeriodicAnnouncementCommand::encodeBrief(std::ostream& strm) const
{
    return strm;
}

