#ifndef MANAGEMENTCONSOLE_H
#define MANAGEMENTCONSOLE_H
#include <pthread.h>
#include <string>
#include "Acd.h"

#define MAXCLIENTS 100

class ManagementConsole{
private:
    Acd         *mAcd;
    pthread_t   mThreadHandle;
    bool        mQuit;
    int         mPort;
    int         mServerSocket;
    std::string mBindAddress;
    int         mClients[MAXCLIENTS];

    void setNonBlocking(int sock);
    void acceptClient();
    void readClient(int index);
    void processRequest(std::string request, int index);

public:
	ManagementConsole(int port, std::string bindAddr, Acd* acd);
	~ManagementConsole();

    void start();
    void stop();

    void run();

};

#endif

